## ffmpeg2theora 0.23

=== Makefile ===
all:
	scons

clean:
	scons -c

install:
	scons install

dist:
	bzr export ffmpeg2theora-`grep pkg_version= SConstruct | cut -d\" -f2`.tar.bz2

=== SConstruct ===
# SCons build specification
from glob import glob
import os

import SCons


pkg_version="0.23"
pkg_name="ffmpeg2theora"

scons_version=(0,97,0)
#this is needed to make scons -h work, so not checking for it right now
#(i.e. ubuntu hardy only ships with 0.97..)
#scons_version=(0,98,0)

try:
    EnsureSConsVersion(*scons_version)
except TypeError:
    print 'SCons %d.%d.%d or greater is required, but you have an older version' % scons_version
    Exit(2)

opts = Options()
opts.AddOptions(
  BoolOption('static', 'Set to 1 for static linking', 0),
  BoolOption('debug', 'Set to 1 to enable debugging', 0),
  ('prefix', 'install architecture-independent files in', '/usr/local'),
  ('bindir', 'user executables', 'PREFIX/bin'),
  ('mandir', 'man documentation', 'PREFIX/man'),
  ('destdir', 'extra install time prefix', ''),
  ('APPEND_CCFLAGS', 'Additional C/C++ compiler flags'),
  ('APPEND_LINKFLAGS', 'Additional linker flags'),
  BoolOption('crossmingw', 'Set to 1 for crosscompile with mingw', 0)
)
env = Environment(options = opts)
Help(opts.GenerateHelpText(env))

pkg_flags="--cflags --libs"
if env['static']:
  pkg_flags+=" --static"
  env.Append(LINKFLAGS=["-static"])

if env['crossmingw']:
    env.Tool('crossmingw', toolpath = ['scons-tools'])

prefix = env['prefix']
if env['destdir']:
  if prefix.startswith('/'): prefix = prefix[1:]
  prefix = os.path.join(env['destdir'], prefix)
man_dir = env['mandir'].replace('PREFIX', prefix)
bin_dir = env['bindir'].replace('PREFIX', prefix)

env.Append(CPPPATH=['.'])
env.Append(CCFLAGS=[
  '-DPACKAGE_VERSION=\\"%s\\"' % pkg_version,
  '-DPACKAGE_STRING=\\"%s-%s\\"' % (pkg_name, pkg_version),
  '-DPACKAGE=\\"%s\\"' % pkg_name,
  '-D_FILE_OFFSET_BITS=64'
])

env.Append(CCFLAGS = Split('$APPEND_CCFLAGS'))
env.Append(LINKFLAGS = Split('$APPEND_LINKFLAGS'))

if env['debug'] and env['CC'] == 'gcc':
  env.Append(CCFLAGS=["-g", "-O2", "-Wall"])

if GetOption("help"):
    Return()

def TryAction(action):
    import os
    ret = os.system(action)
    if ret == 0:
        return (1, '')
    return (0, '')

def CheckPKGConfig(context, version): 
  context.Message( 'Checking for pkg-config... ' ) 
  ret = TryAction('pkg-config --atleast-pkgconfig-version=%s' % version)[0] 
  context.Result( ret ) 
  return ret 

def CheckPKG(context, name): 
  context.Message( 'Checking for %s... ' % name )
  if os.environ.get('PKG_CONFIG_PATH', ''):
    action = 'PKG_CONFIG_PATH=%s pkg-config --exists "%s"' % (os.environ['PKG_CONFIG_PATH'], name)
  else:
    action = 'pkg-config --exists "%s"' % name
  ret = TryAction(action)[0]
  context.Result( ret ) 
  return ret

conf = Configure(env, custom_tests = {
  'CheckPKGConfig' : CheckPKGConfig,
  'CheckPKG' : CheckPKG,
  })

pkgconfig_version='0.15.0'
if not conf.CheckPKGConfig(pkgconfig_version): 
   print 'pkg-config >= %s not found.' % pkgconfig_version 
   Exit(1)

XIPH_LIBS="ogg >= 1.1 vorbis vorbisenc theora >= 1.0beta1"

if not conf.CheckPKG(XIPH_LIBS): 
  print 'some xiph libs are missing, ffmpeg2theora depends on %s' % XIPH_LIBS
  Exit(1) 
env.ParseConfig('pkg-config %s "%s"' % (pkg_flags, XIPH_LIBS))

FFMPEG_LIBS="libavcodec libavformat libavdevice libpostproc libswscale"
if os.path.exists("./ffmpeg"):
  os.environ['PKG_CONFIG_PATH'] = "./ffmpeg/libavutil:./ffmpeg/libavformat:./ffmpeg/libavcodec:./ffmpeg/libavdevice:./ffmpeg/libswscale:./ffmpeg/libpostproc:" + os.environ.get('PKG_CONFIG_PATH', '')
if not conf.CheckPKG(FFMPEG_LIBS): 
  print """
      Could not find %s.
      You can install it via
       sudo apt-get install %s
      or update PKG_CONFIG_PATH to point to ffmpeg's source folder
      or run ./get_ffmpeg_svn.sh (for more information see INSTALL)
  """ %(FFMPEG_LIBS, " ".join(["%s-dev"%l for l in FFMPEG_LIBS.split()]))
  Exit(1) 
for lib in FFMPEG_LIBS.split():
    env.ParseConfig('pkg-config %s "%s"' % (pkg_flags, lib))

if conf.CheckCHeader('libavformat/framehook.h'):
    env.Append(CCFLAGS=[
      '-DHAVE_FRAMEHOOK'
    ])

KATE_LIBS="oggkate"
if os.path.exists("./libkate/misc/pkgconfig"):
  os.environ['PKG_CONFIG_PATH'] = "./libkate/misc/pkgconfig:" + os.environ.get('PKG_CONFIG_PATH', '')
if os.path.exists("./libkate/pkg/pkgconfig"):
  os.environ['PKG_CONFIG_PATH'] = "./libkate/pkg/pkgconfig:" + os.environ.get('PKG_CONFIG_PATH', '')
if conf.CheckPKG(KATE_LIBS):
  env.ParseConfig('pkg-config %s "%s"' % (pkg_flags, KATE_LIBS))
  env.Append(CCFLAGS=['-DHAVE_KATE', '-DHAVE_OGGKATE'])
else:
  print """
      Could not find libkate. Subtitles support will be disabled.
      You can also run ./get_libkate.sh (for more information see INSTALL)
      or update PKG_CONFIG_PATH to point to libkate's source folder
  """
env = conf.Finish()

# ffmpeg2theora 
ffmpeg2theora = env.Clone()
ffmpeg2theora_sources = glob('src/*.c')
ffmpeg2theora.Program('ffmpeg2theora', ffmpeg2theora_sources)

ffmpeg2theora.Install(bin_dir, 'ffmpeg2theora')
ffmpeg2theora.Install(man_dir + "/man1", 'ffmpeg2theora.1')
ffmpeg2theora.Alias('install', prefix)

## ffmpeg2theora 0.24

=== Makefile ===
all:
	scons

clean:
	scons -c

install:
	scons install $(PREFIX)

dist:
	svn export . ffmpeg2theora-`grep pkg_version= SConstruct | cut -d\" -f2`
	tar cjf ffmpeg2theora-`grep pkg_version= SConstruct | cut -d\" -f2`.tar.bz2 ffmpeg2theora-`grep pkg_version= SConstruct | cut -d\" -f2`
	rm -r ffmpeg2theora-`grep pkg_version= SConstruct | cut -d\" -f2`

=== SConstruct ===
--- 
+++ 
@@ -5,7 +5,7 @@
 import SCons
 
 
-pkg_version="0.23"
+pkg_version="0.24"
 pkg_name="ffmpeg2theora"
 
 scons_version=(0,97,0)
@@ -66,6 +66,13 @@
 if GetOption("help"):
     Return()
 
+def ParsePKGConfig(env, name): 
+  if os.environ.get('PKG_CONFIG_PATH', ''):
+    action = 'PKG_CONFIG_PATH=%s pkg-config %s "%s"' % (os.environ['PKG_CONFIG_PATH'], pkg_flags, name)
+  else:
+    action = 'pkg-config %s "%s"' % (pkg_flags, name)
+  return env.ParseConfig(action)
+
 def TryAction(action):
     import os
     ret = os.system(action)
@@ -104,7 +111,7 @@
 if not conf.CheckPKG(XIPH_LIBS): 
   print 'some xiph libs are missing, ffmpeg2theora depends on %s' % XIPH_LIBS
   Exit(1) 
-env.ParseConfig('pkg-config %s "%s"' % (pkg_flags, XIPH_LIBS))
+ParsePKGConfig(env, XIPH_LIBS)
 
 FFMPEG_LIBS="libavcodec libavformat libavdevice libpostproc libswscale"
 if os.path.exists("./ffmpeg"):
@@ -119,7 +126,7 @@
   """ %(FFMPEG_LIBS, " ".join(["%s-dev"%l for l in FFMPEG_LIBS.split()]))
   Exit(1) 
 for lib in FFMPEG_LIBS.split():
-    env.ParseConfig('pkg-config %s "%s"' % (pkg_flags, lib))
+    ParsePKGConfig(env, lib)
 
 if conf.CheckCHeader('libavformat/framehook.h'):
     env.Append(CCFLAGS=[
@@ -132,7 +139,7 @@
 if os.path.exists("./libkate/pkg/pkgconfig"):
   os.environ['PKG_CONFIG_PATH'] = "./libkate/pkg/pkgconfig:" + os.environ.get('PKG_CONFIG_PATH', '')
 if conf.CheckPKG(KATE_LIBS):
-  env.ParseConfig('pkg-config %s "%s"' % (pkg_flags, KATE_LIBS))
+  ParsePKGConfig(env, KATE_LIBS)
   env.Append(CCFLAGS=['-DHAVE_KATE', '-DHAVE_OGGKATE'])
 else:
   print """

## ffmpeg2theora 0.27

=== SConstruct ===
--- 
+++ 
@@ -4,8 +4,15 @@
 
 import SCons
 
+def svnversion():
+    f = os.popen("svnversion")
+    version = f.read().strip()
+    f.close()
+    return version
 
-pkg_version="0.24"
+pkg_version="0.27"
+#pkg_version +="+svn" + svnversion()
+
 pkg_name="ffmpeg2theora"
 
 scons_version=(0,97,0)
@@ -23,12 +30,13 @@
 opts.AddOptions(
   BoolOption('static', 'Set to 1 for static linking', 0),
   BoolOption('debug', 'Set to 1 to enable debugging', 0),
-  ('prefix', 'install architecture-independent files in', '/usr/local'),
+  ('prefix', 'install files in', '/usr/local'),
   ('bindir', 'user executables', 'PREFIX/bin'),
   ('mandir', 'man documentation', 'PREFIX/man'),
   ('destdir', 'extra install time prefix', ''),
   ('APPEND_CCFLAGS', 'Additional C/C++ compiler flags'),
   ('APPEND_LINKFLAGS', 'Additional linker flags'),
+  BoolOption('libkate', 'enable libkate support', 1),
   BoolOption('crossmingw', 'Set to 1 for crosscompile with mingw', 0)
 )
 env = Environment(options = opts)
@@ -65,6 +73,8 @@
 
 if GetOption("help"):
     Return()
+
+env.PrependENVPath ('PATH', os.environ['PATH'])
 
 def ParsePKGConfig(env, name): 
   if os.environ.get('PKG_CONFIG_PATH', ''):
@@ -106,26 +116,43 @@
    print 'pkg-config >= %s not found.' % pkgconfig_version 
    Exit(1)
 
-XIPH_LIBS="ogg >= 1.1 vorbis vorbisenc theora >= 1.0beta1"
+if not conf.CheckPKG("ogg >= 1.1"): 
+  print 'ogg >= 1.1 missing'
+  Exit(1) 
+
+if not conf.CheckPKG("vorbis"): 
+  print 'vorbis missing'
+  Exit(1) 
+
+if not conf.CheckPKG("vorbisenc"): 
+  print 'vorbisenc missing'
+  Exit(1) 
+
+if not conf.CheckPKG("theoraenc >= 1.1.0"): 
+  print 'theoraenc >= 1.1.0 missing'
+  Exit(1) 
+
+XIPH_LIBS="ogg >= 1.1 vorbis vorbisenc theoraenc >= 1.1.0"
 
 if not conf.CheckPKG(XIPH_LIBS): 
   print 'some xiph libs are missing, ffmpeg2theora depends on %s' % XIPH_LIBS
   Exit(1) 
 ParsePKGConfig(env, XIPH_LIBS)
 
-FFMPEG_LIBS="libavcodec libavformat libavdevice libpostproc libswscale"
+FFMPEG_LIBS=["libavcodec >= 52.30.0", "libavdevice", "libavformat", "libpostproc", "libswscale"]
 if os.path.exists("./ffmpeg"):
   os.environ['PKG_CONFIG_PATH'] = "./ffmpeg/libavutil:./ffmpeg/libavformat:./ffmpeg/libavcodec:./ffmpeg/libavdevice:./ffmpeg/libswscale:./ffmpeg/libpostproc:" + os.environ.get('PKG_CONFIG_PATH', '')
-if not conf.CheckPKG(FFMPEG_LIBS): 
+if not conf.CheckPKG(' '.join(FFMPEG_LIBS)): 
   print """
       Could not find %s.
       You can install it via
        sudo apt-get install %s
       or update PKG_CONFIG_PATH to point to ffmpeg's source folder
       or run ./get_ffmpeg_svn.sh (for more information see INSTALL)
-  """ %(FFMPEG_LIBS, " ".join(["%s-dev"%l for l in FFMPEG_LIBS.split()]))
+  """ %(" ".join(FFMPEG_LIBS), " ".join(["%s-dev"%l.split()[0] for l in FFMPEG_LIBS]))
   Exit(1) 
-for lib in FFMPEG_LIBS.split():
+
+for lib in FFMPEG_LIBS:
     ParsePKGConfig(env, lib)
 
 if conf.CheckCHeader('libavformat/framehook.h'):
@@ -134,19 +161,31 @@
     ])
 
 KATE_LIBS="oggkate"
-if os.path.exists("./libkate/misc/pkgconfig"):
-  os.environ['PKG_CONFIG_PATH'] = "./libkate/misc/pkgconfig:" + os.environ.get('PKG_CONFIG_PATH', '')
-if os.path.exists("./libkate/pkg/pkgconfig"):
-  os.environ['PKG_CONFIG_PATH'] = "./libkate/pkg/pkgconfig:" + os.environ.get('PKG_CONFIG_PATH', '')
-if conf.CheckPKG(KATE_LIBS):
-  ParsePKGConfig(env, KATE_LIBS)
-  env.Append(CCFLAGS=['-DHAVE_KATE', '-DHAVE_OGGKATE'])
-else:
-  print """
-      Could not find libkate. Subtitles support will be disabled.
-      You can also run ./get_libkate.sh (for more information see INSTALL)
-      or update PKG_CONFIG_PATH to point to libkate's source folder
-  """
+if env['libkate']:
+  if os.path.exists("./libkate/misc/pkgconfig"):
+    os.environ['PKG_CONFIG_PATH'] = "./libkate/misc/pkgconfig:" + os.environ.get('PKG_CONFIG_PATH', '')
+  if os.path.exists("./libkate/pkg/pkgconfig"):
+    os.environ['PKG_CONFIG_PATH'] = "./libkate/pkg/pkgconfig:" + os.environ.get('PKG_CONFIG_PATH', '')
+  if conf.CheckPKG(KATE_LIBS):
+    ParsePKGConfig(env, KATE_LIBS)
+    env.Append(CCFLAGS=['-DHAVE_KATE', '-DHAVE_OGGKATE'])
+  else:
+    print """
+        Could not find libkate. Subtitles support will be disabled.
+        You can also run ./get_libkate.sh (for more information see INSTALL)
+        or update PKG_CONFIG_PATH to point to libkate's source folder
+    """
+
+if conf.CheckCHeader('iconv.h'):
+    env.Append(CCFLAGS=[
+      '-DHAVE_ICONV'
+    ])
+    if conf.CheckLib('iconv'):
+        env.Append(LIBS=['iconv'])
+
+if env['static']:
+    env.Append(LIBS=['m', 'dl'])
+
 env = conf.Finish()
 
 # ffmpeg2theora

=== debian/changelog ===
ffmpeg2theora (0.27-2) unstable; urgency=low

  * Switch to dpkg-source 3.0 (quilt) format
  * Add ubuntu patch to build against libav/0.7. Last upstream version (0.28)
    fails to build so let's use this patch for now. (Closes: #638245)
  * Now we have 0.27 in unstable, so close "New version 0.25 out" whishlist.
    (Closes: #549967)

 -- Tiago Bortoletto Vaz <tiago@debian.org>  Thu, 29 Sep 2011 00:41:10 -0300

ffmpeg2theora (0.27-1) experimental; urgency=low

  * New upstream version
  * debian/control:
    - add myself as uploader
    - Standards-Version 3.8.4

 -- Tiago Bortoletto Vaz <tiago@debian.org>  Tue, 22 Jun 2010 21:14:40 -0300

ffmpeg2theora (0.24-2) unstable; urgency=low

  * debian/control: section changed (graphics -> video)
  * debian/control: fix Vcs-* fields

 -- RISKO Gergely <risko@debian.org>  Fri, 20 Mar 2009 02:01:52 +0200

ffmpeg2theora (0.24-1) unstable; urgency=low

  * New Upstream Version
    Closes: #510826, #404646, #418701, #420232, #461421, #517470
  * debian/rules:
     - removed simple-patchsys
     - removed autotools support
     - added scons support (with debian/cdbs/scons* files)
  * debian/control:
     - updated build-dependencies
     - Standards-Version 3.8.1
     - added Vcs-* fields
  * ffmpeg2theora.1:
     - adapting changes from Kapil, thanks

 -- RISKO Gergely <risko@debian.org>  Fri, 20 Mar 2009 02:01:52 +0200

ffmpeg2theora (0.21-0.1) unstable; urgency=low

  * Non-maintainer upload to fix RC bugs.
  * New upstream release (0.21).
    Closes: #484813, #482218, #487911.
  * debian/control:
    - added libavutil-dev, libavdevice-dev, libfaad-dev, libx11-dev,
      libxext-dev to dependencies.
    - added Homepage field
    - Standards-Version 3.8.0
  * debian/rules:
    - added cdbs simple-patchsys include.
    - added "as-needed" and "no-undefined" flags for linker
      to reduce dependencies.
  * debian/patches/01-fix_includes.patch: point the include
    directives in ffmpeg2theora.c to the correct directories.
  * debian/patches/02-fix_hyphen-used-as-minus_in_manpage.patch:
    replaced incorrect uses of hyphen as minus in ffmpeg2theora.1.

 -- Kapil Hari Paranjape <kapil@debian.org>  Thu, 26 Jun 2008 06:47:53 +0530

ffmpeg2theora (0.19-1) unstable; urgency=low

  * New upstream release (closes: #429937, #368588)
  * removed now unneeded libdc1394-dev dependecy (closes: #413663)
  * new build with new version of libavformat0d (closes: #430037)
  * added libswscale-dev new dependency

 -- RISKO Gergely <risko@debian.org>  Sat, 28 Jul 2007 19:14:08 +0200

ffmpeg2theora (0.16-2) unstable; urgency=low

  * added libgsm-dev and libdc1394-dev to build-depends (closes: #366025)

 -- RISKO Gergely <risko@debian.org>  Tue, 30 May 2006 16:43:46 +0200

ffmpeg2theora (0.16-1) unstable; urgency=low

  * New upstream release
    - fixes segfault when permission denied on output (closes: #352272)
    - fixes misleading error message for wrong input format (closes: #338872)
  * ftbfs fixed, i was silly when added -lgsm -ldc1394_control the day
    before yesterday (closes: #352547)

 -- RISKO Gergely <risko@debian.org>  Mon, 13 Feb 2006 01:16:25 +0100

ffmpeg2theora (0.15-1) unstable; urgency=low

  * New upstream release (closes: #335854)
  * '-ldc1394_control -lgsm' added to LDFLAGS in rules (closes: #333636)
  * changed FSF's postal address (thanks lintian!)

 -- RISKO Gergely <risko@debian.org>  Sat, 11 Feb 2006 14:20:15 +0100

ffmpeg2theora (0.13+svn20050704-1) unstable; urgency=low

  * initial upload (closes: #279503)

 -- RISKO Gergely <risko@debian.org>  Mon,  4 Jul 2005 23:10:00 +0200

=== debian/control ===
Source: ffmpeg2theora
Section: video
Priority: optional
Maintainer: RISKO Gergely <risko@debian.org>
Uploaders: Tiago Bortoletto Vaz <tiago@debian.org>
Vcs-Browser: http://git.debian.org/?p=collab-maint/ffmpeg2theora.git;a=summary
Vcs-Git: git://git.debian.org/collab-maint/ffmpeg2theora.git
Build-Depends: quilt, debhelper (>= 7.0.50~), libavcodec-dev (>= 4:0.6), libavutil-dev, libpostproc-dev (>= 4:0.6),
 libswscale-dev (>= 4:0.6), libavformat-dev (>= 4:0.6), libavdevice-dev (>= 4:0.6), libogg-dev, libvorbis-dev,
 libtheora-dev, scons, pkg-config, libkate-dev, liboggkate-dev
Homepage: http://v2v.cc/~j/ffmpeg2theora/
Standards-Version: 3.9.2

Package: ffmpeg2theora
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Theora video encoder using ffmpeg
 This package provides a command-line tool to encode/recode various
 video formats (basically everything that ffmpeg can read) into Theora,
 the free video codec.

## ffmpeg2theora 0.29

=== Makefile ===
all:
	scons

clean:
	scons -c

install:
	scons install $(PREFIX)

dist:
	svn export . ffmpeg2theora-`grep ^pkg_version= SConstruct | cut -d\" -f2`
	tar cjf ffmpeg2theora-`grep ^pkg_version= SConstruct | cut -d\" -f2`.tar.bz2 ffmpeg2theora-`grep ^pkg_version= SConstruct | cut -d\" -f2`
	rm -r ffmpeg2theora-`grep ^pkg_version= SConstruct | cut -d\" -f2`

=== SConstruct ===
# SCons build specification
# vi:si:et:sw=2:sts=2:ts=2
from glob import glob
import os

import SCons

def version():
    f = os.popen("./version.sh")
    version = f.read().strip()
    f.close()
    return version

pkg_version="0.29"

pkg_name="ffmpeg2theora"

scons_version=(1,2,0)

try:
    EnsureSConsVersion(*scons_version)
except TypeError:
    print 'SCons %d.%d.%d or greater is required, but you have an older version' % scons_version
    Exit(2)

opts = Variables()
opts.AddVariables(
  BoolVariable('static', 'Set to 1 for static linking', 0),
  BoolVariable('debug', 'Set to 1 to enable debugging', 0),
  BoolVariable('build_ffmpeg', 'Set to 1 to build local copy of ffmpeg', 0),
  ('prefix', 'install files in', '/usr/local'),
  ('bindir', 'user executables', 'PREFIX/bin'),
  ('mandir', 'man documentation', 'PREFIX/man'),
  ('destdir', 'extra install time prefix', ''),
  ('APPEND_CCFLAGS', 'Additional C/C++ compiler flags'),
  ('APPEND_LINKFLAGS', 'Additional linker flags'),
  BoolVariable('libkate', 'enable libkate support', 1),
  BoolVariable('crossmingw', 'Set to 1 for crosscompile with mingw', 0)
)
env = Environment(options = opts)
Help(opts.GenerateHelpText(env))

pkg_flags="--cflags --libs"
if env['static']:
  pkg_flags+=" --static"
  env.Append(LINKFLAGS=["-static"])

if env['crossmingw']:
    env.Tool('crossmingw', toolpath = ['scons-tools'])

prefix = env['prefix']
if env['destdir']:
  if prefix.startswith('/'): prefix = prefix[1:]
  prefix = os.path.join(env['destdir'], prefix)
man_dir = env['mandir'].replace('PREFIX', prefix)
bin_dir = env['bindir'].replace('PREFIX', prefix)

env.Append(CPPPATH=['.'])
env.Append(CCFLAGS=[
  '-DPACKAGE_VERSION=\\"%s\\"' % pkg_version,
  '-DPACKAGE_STRING=\\"%s-%s\\"' % (pkg_name, pkg_version),
  '-DPACKAGE=\\"%s\\"' % pkg_name,
  '-D_FILE_OFFSET_BITS=64'
])

env.Append(CCFLAGS = Split('$APPEND_CCFLAGS'))
env.Append(LINKFLAGS = Split('$APPEND_LINKFLAGS'))

if env['debug'] and env['CC'] == 'gcc':
  env.Append(CCFLAGS=["-g", "-O2", "-Wall"])

if GetOption("help"):
    Return()

def ParsePKGConfig(env, name): 
  if os.environ.get('PKG_CONFIG_PATH', ''):
    action = 'PKG_CONFIG_PATH=%s pkg-config %s "%s"' % (os.environ['PKG_CONFIG_PATH'], pkg_flags, name)
  else:
    action = 'pkg-config %s "%s"' % (pkg_flags, name)
  return env.ParseConfig(action)

def TryAction(action):
    import os
    ret = os.system(action)
    if ret == 0:
        return (1, '')
    return (0, '')

def CheckPKGConfig(context, version): 
  context.Message( 'Checking for pkg-config... ' ) 
  ret = TryAction('pkg-config --atleast-pkgconfig-version=%s' % version)[0] 
  context.Result( ret ) 
  return ret 

def CheckPKG(context, name): 
  context.Message( 'Checking for %s... ' % name )
  if os.environ.get('PKG_CONFIG_PATH', ''):
    action = 'PKG_CONFIG_PATH=%s pkg-config --exists "%s"' % (os.environ['PKG_CONFIG_PATH'], name)
  else:
    action = 'pkg-config --exists "%s"' % name
  ret = TryAction(action)[0]
  context.Result( ret ) 
  return ret

env.PrependENVPath ('PATH', os.environ['PATH'])

conf = Configure(env, custom_tests = {
  'CheckPKGConfig' : CheckPKGConfig,
  'CheckPKG' : CheckPKG,
})

if env["build_ffmpeg"]:
  if env.GetOption('clean'):
    TryAction("cd ffmpeg;make distclean")
  else:
    TryAction("./build_ffmpeg.sh")

if not env.GetOption('clean'):
  pkgconfig_version='0.15.0'
  if not conf.CheckPKGConfig(pkgconfig_version): 
     print 'pkg-config >= %s not found.' % pkgconfig_version 
     Exit(1)

  if not conf.CheckPKG("ogg >= 1.1"): 
    print 'ogg >= 1.1 missing'
    Exit(1) 

  if not conf.CheckPKG("vorbis"): 
    print 'vorbis missing'
    Exit(1) 

  if not conf.CheckPKG("vorbisenc"): 
    print 'vorbisenc missing'
    Exit(1) 

  if not conf.CheckPKG("theoraenc >= 1.1.0"): 
    print 'theoraenc >= 1.1.0 missing'
    Exit(1) 

  XIPH_LIBS="ogg >= 1.1 vorbis vorbisenc theoraenc >= 1.1.0"

  if not conf.CheckPKG(XIPH_LIBS): 
    print 'some xiph libs are missing, ffmpeg2theora depends on %s' % XIPH_LIBS
    Exit(1) 
  ParsePKGConfig(env, XIPH_LIBS)

  FFMPEG_LIBS=[
      "libavdevice",
      "libavformat",
      "libavfilter",
      "libavcodec >= 52.30.0",
      "libpostproc",
      "libswscale",
      "libswresample",
      "libavutil",
  ]
  if os.path.exists("./ffmpeg"):
    pkg_path = list(set(map(os.path.dirname, glob('./ffmpeg/*/*.pc'))))
    pkg_path.append(os.environ.get('PKG_CONFIG_PATH', ''))
    os.environ['PKG_CONFIG_PATH'] = ':'.join(pkg_path)
    env.Append(CCFLAGS=[
      '-Iffmpeg'
    ])

  if not conf.CheckPKG(' '.join(FFMPEG_LIBS)): 
    print """
        Could not find %s.
        You can install it via
         sudo apt-get install %s
        or update PKG_CONFIG_PATH to point to ffmpeg's source folder
        or run ./get_ffmpeg.sh (for more information see INSTALL)
    """ %(" ".join(FFMPEG_LIBS), " ".join(["%s-dev"%l.split()[0] for l in FFMPEG_LIBS]))
    Exit(1) 

  for lib in FFMPEG_LIBS:
      ParsePKGConfig(env, lib)

  if conf.CheckCHeader('libavformat/framehook.h'):
      env.Append(CCFLAGS=[
        '-DHAVE_FRAMEHOOK'
      ])

  KATE_LIBS="oggkate"
  if env['libkate']:
    if os.path.exists("./libkate/misc/pkgconfig"):
      os.environ['PKG_CONFIG_PATH'] = "./libkate/misc/pkgconfig:" + os.environ.get('PKG_CONFIG_PATH', '')
    if os.path.exists("./libkate/pkg/pkgconfig"):
      os.environ['PKG_CONFIG_PATH'] = "./libkate/pkg/pkgconfig:" + os.environ.get('PKG_CONFIG_PATH', '')
    if conf.CheckPKG(KATE_LIBS):
      ParsePKGConfig(env, KATE_LIBS)
      env.Append(CCFLAGS=['-DHAVE_KATE', '-DHAVE_OGGKATE'])
    else:
      print """
          Could not find libkate. Subtitles support will be disabled.
          You can also run ./get_libkate.sh (for more information see INSTALL)
          or update PKG_CONFIG_PATH to point to libkate's source folder
      """

  if conf.CheckCHeader('iconv.h'):
      env.Append(CCFLAGS=[
        '-DHAVE_ICONV'
      ])
      if conf.CheckLib('iconv'):
          env.Append(LIBS=['iconv'])

  if env['crossmingw']:
      env.Append(CCFLAGS=['-Wl,-subsystem,windows'])
      env.Append(LIBS=['m'])
  elif env['static']:
      env.Append(LIBS=['m', 'dl'])


env = conf.Finish()

# ffmpeg2theora 
ffmpeg2theora = env.Clone()
ffmpeg2theora_sources = glob('src/*.c')
ffmpeg2theora.Program('ffmpeg2theora', ffmpeg2theora_sources)

ffmpeg2theora.Install(bin_dir, 'ffmpeg2theora')
ffmpeg2theora.Install(man_dir + "/man1", 'ffmpeg2theora.1')
ffmpeg2theora.Alias('install', prefix)

=== debian/changelog ===
ffmpeg2theora (0.29-2build1) trusty; urgency=low

  * No change rebuild against libav 9.

 -- Dmitrijs Ledkovs <xnox@ubuntu.com>  Sun, 10 Nov 2013 19:12:47 +0000

ffmpeg2theora (0.29-2) unstable; urgency=low

  * Pushing 0.29 to unstable fixes FTBFS. (Closes: #713716)
  * Remove obsolete DM-Upload-Allowed field.
  * Replace uncanonical URI from VCS-* fields.
  * Update Standards-Version.

 -- Tiago Bortoletto Vaz <tiago@debian.org>  Sat, 22 Jun 2013 11:37:44 -0400

ffmpeg2theora (0.29-1) experimental; urgency=low

  * Migrate source to pkg-multimedia git repository tree.
  * Add pkg-multimedia as maintainer
  * New upstream version. (Closes: #692914, #652705)

 -- Tiago Bortoletto Vaz <tiago@debian.org>  Thu, 15 Nov 2012 15:05:50 -0500

=== debian/control ===
Source: ffmpeg2theora
Section: video
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Tiago Bortoletto Vaz <tiago@debian.org>, RISKO Gergely <risko@debian.org>
Vcs-Browser: http://anonscm.debian.org/git/pkg-multimedia/ffmpeg2theora.git
Vcs-Git: git://anonscm.debian.org/git/pkg-multimedia/ffmpeg2theora.git
Build-Depends: quilt, debhelper (>= 7.0.50~), libavcodec-dev (>= 4:0.6), libavutil-dev, libpostproc-dev (>= 4:0.6),
 libswscale-dev (>= 4:0.6), libavformat-dev (>= 4:0.6), libavdevice-dev (>= 4:0.6), libogg-dev, libvorbis-dev,
 libtheora-dev, scons, pkg-config, libkate-dev, liboggkate-dev, libavfilter-dev
Homepage: http://v2v.cc/~j/ffmpeg2theora/
Standards-Version: 3.9.4

Package: ffmpeg2theora
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Theora video encoder using ffmpeg
 This package provides a command-line tool to encode/recode various
 video formats (basically everything that ffmpeg can read) into Theora,
 the free video codec.

=== debian/rules ===
#!/usr/bin/make -f

#DEB_SCONS_OPTIONS := prefix=/usr destdir=$(DEB_DESTDIR) mandir=PREFIX/share/man

#PREFIX="prefix=$(CURDIR)/debian/ffmpeg2theora/usr destdir=$(CURDIR)/debian/ffmpeg2theora mandir=$(CURDIR)/debian/usr/share/man"

%:
	dh $@ --with quilt

#override_dh_auto_build:
#	scons
#
#override_dh_auto_install:
#	PREFIX="destdir=$(CURDIR)/debian/ffmpeg2theora prefix=/usr mandir=$(CURDIR)/debian/usr/share/man"; make install

override_dh_auto_clean:
	dh_auto_clean
	rm -rf .sconf_temp/ .sconsign.dblite config.log

=== debian/watch ===
# watch control file for uscan
version=2
http://www.v2v.cc/~j/ffmpeg2theora/download.html        ffmpeg2theora-([\d\.]*)\.tar\.bz2

## ffmpeg2theora 0.29.0~git+20140316

=== SConstruct ===
--- 
+++ 
@@ -6,12 +6,13 @@
 import SCons
 
 def version():
+    #return "0.29"
     f = os.popen("./version.sh")
     version = f.read().strip()
     f.close()
     return version
 
-pkg_version="0.29"
+pkg_version=version()
 
 pkg_name="ffmpeg2theora"
 
@@ -151,7 +152,6 @@
       "libavcodec >= 52.30.0",
       "libpostproc",
       "libswscale",
-      "libswresample",
       "libavutil",
   ]
   if os.path.exists("./ffmpeg"):
@@ -160,6 +160,19 @@
     os.environ['PKG_CONFIG_PATH'] = ':'.join(pkg_path)
     env.Append(CCFLAGS=[
       '-Iffmpeg'
+    ])
+    for lib in FFMPEG_LIBS:
+      lib = lib.split(' ')[0]
+      env.Append(LINKFLAGS=[
+        '-Lffmpeg/' + lib
+      ])
+
+  if conf.CheckPKG('libavresample'):
+    FFMPEG_LIBS.append('libavresample')
+  else:
+    FFMPEG_LIBS.append('libswresample')
+    env.Append(CCFLAGS=[
+      '-DUSE_SWRESAMPLE'
     ])
 
   if not conf.CheckPKG(' '.join(FFMPEG_LIBS)):

=== debian/changelog ===
ffmpeg2theora (0.29.0~git+20140316-3) unstable; urgency=medium

  * Team upload.
  * debian/patches/link-libm.patch: Link with libm for ceil. (Closes: #768674)

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 09 Nov 2014 13:09:49 +0100

ffmpeg2theora (0.29.0~git+20140316-2) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.

 -- Sebastian Ramacher <sramacher@debian.org>  Mon, 12 May 2014 01:09:43 +0200

ffmpeg2theora (0.29.0~git+20140316-1) experimental; urgency=medium

  * Team upload.
  [ Tiago Bortoletto Vaz ]
  * Using last upstream changes which fixes a FTBFS with libav10. Thanks to
    Moritz Muehlenhoff. (Closes: #739237)

  [ Reinhard Tartler ]
  * Upload to experimental
  * compile against libav10, and build against libavresample
  * add libavresample.patch to allow compilation against libavresample
  * Pass correct PREFIX an DESTDIR variables to the upstream build system
  * Update Standards-Version to 3.9.5

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 30 Mar 2014 21:52:57 -0400

=== debian/control ===
Source: ffmpeg2theora
Section: video
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Tiago Bortoletto Vaz <tiago@debian.org>,
           RISKO Gergely <risko@debian.org>
Vcs-Browser: http://anonscm.debian.org/git/pkg-multimedia/ffmpeg2theora.git
Vcs-Git: git://anonscm.debian.org/git/pkg-multimedia/ffmpeg2theora.git
Build-Depends: debhelper (>= 7.0.50~),
               libavcodec-dev (>= 6:10~),
               libavdevice-dev (>= 6:10~),
               libavfilter-dev,
               libavformat-dev (>= 6:10~),
               libavresample-dev (>= 6:10~),
               libavutil-dev,
               libkate-dev,
               libogg-dev,
               liboggkate-dev,
               libpostproc-dev,
               libswscale-dev (>= 6:10~),
               libtheora-dev,
               libvorbis-dev,
               pkg-config,
               quilt,
               scons
Homepage: http://v2v.cc/~j/ffmpeg2theora/
Standards-Version: 3.9.5

Package: ffmpeg2theora
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Theora video encoder using ffmpeg
 This package provides a command-line tool to encode/recode various
 video formats (basically everything that ffmpeg can read) into Theora,
 the free video codec.

=== debian/rules ===
--- 
+++ 
@@ -9,9 +9,9 @@
 
 #override_dh_auto_build:
 #	scons
-#
-#override_dh_auto_install:
-#	PREFIX="destdir=$(CURDIR)/debian/ffmpeg2theora prefix=/usr mandir=$(CURDIR)/debian/usr/share/man"; make install
+
+override_dh_auto_install:
+	dh_auto_install -- PREFIX="prefix=/usr destdir=$(CURDIR)/debian/ffmpeg2theora mandir=$(CURDIR)"
 
 override_dh_auto_clean:
 	dh_auto_clean

## ffmpeg2theora 0.30

=== Makefile ===
all:
	scons

clean:
	scons -c

install:
	scons install $(PREFIX)

dist:
	git archive --format=tar --prefix=ffmpeg2theora-`./version.sh`/ master | bzip2 >ffmpeg2theora-`./version.sh`.tar.bz2
	ls -lah ffmpeg2theora-`./version.sh`.tar.bz2

=== SConstruct ===
--- 
+++ 
@@ -152,6 +152,7 @@
       "libavcodec >= 52.30.0",
       "libpostproc",
       "libswscale",
+      "libswresample",
       "libavutil",
   ]
   if os.path.exists("./ffmpeg"):
@@ -167,13 +168,13 @@
         '-Lffmpeg/' + lib
       ])
 
-  if conf.CheckPKG('libavresample'):
-    FFMPEG_LIBS.append('libavresample')
-  else:
+  if conf.CheckPKG('libswresample'):
     FFMPEG_LIBS.append('libswresample')
     env.Append(CCFLAGS=[
       '-DUSE_SWRESAMPLE'
     ])
+  elif conf.CheckPKG('libavresample'):
+    FFMPEG_LIBS.append('libavresample')
 
   if not conf.CheckPKG(' '.join(FFMPEG_LIBS)): 
     print """

=== debian/changelog ===
ffmpeg2theora (0.30-2) unstable; urgency=medium

  * Team upload

  [ Ondřej Nový ]
  * d/control: Set Vcs-* to salsa.debian.org

  [ Felipe Sateler ]
  * Change maintainer address to debian-multimedia@lists.debian.org

  [ Ondřej Nový ]
  * Use debhelper-compat instead of debian/compat

  [ Sebastian Ramacher ]
  * debian/control:
    - Bump debhelper compat to 12
    - Bump Standards-Version

  [ Phil Wyett ]
  * Use Python 3 print() (Closes: #947560)

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 02 Feb 2020 15:33:33 +0100

ffmpeg2theora (0.30-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
    - Fix building against FFmpeg 2.9/3.0. (Closes: #803811)
  * debian/patches/libavresample.patch: Removed, no longer needed.
  * debian/control:
    - Update Standards-Version.
    - Update B-D for ffmpeg.
    - Update Vcs-*.
  * debian/rules: Honor CFLAGS, LDFLAGS and CPPFLAGS.
  * debian/{control,compat}: Bump compat for automatic dbg packages.

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 06 Feb 2016 22:14:59 +0100

=== debian/control ===
Source: ffmpeg2theora
Section: video
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Tiago Bortoletto Vaz <tiago@debian.org>,
           RISKO Gergely <risko@debian.org>
Vcs-Browser: https://salsa.debian.org/multimedia-team/ffmpeg2theora
Vcs-Git: https://salsa.debian.org/multimedia-team/ffmpeg2theora.git
Build-Depends: debhelper-compat (= 12),
               libavcodec-dev (>= 6:10~),
               libavdevice-dev (>= 6:10~),
               libavfilter-dev,
               libavformat-dev (>= 6:10~),
               libavutil-dev,
               libkate-dev,
               libogg-dev,
               liboggkate-dev,
               libpostproc-dev,
               libswresample-dev (>= 6:10~),
               libswscale-dev (>= 6:10~),
               libtheora-dev,
               libvorbis-dev,
               pkg-config,
               scons
Homepage: http://v2v.cc/~j/ffmpeg2theora/
Standards-Version: 4.5.0

Package: ffmpeg2theora
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Theora video encoder using ffmpeg
 This package provides a command-line tool to encode/recode various
 video formats (basically everything that ffmpeg can read) into Theora,
 the free video codec.

=== debian/rules ===
#!/usr/bin/make -f

DEB_SCONS_OPTIONS := prefix=/usr destdir=$(CURDIR)/debian/ffmpeg2theora mandir=$(CURDIR)
DEB_SCONS_OPTIONS += APPEND_CCFLAGS="$(CPPFLAGS) $(CFLAGS)"
DEB_SCONS_OPTIONS += APPEND_LINKFLAGS="$(LDFLAGS)"


%:
	dh $@

override_dh_auto_build:
	scons $(DEB_SCONS_OPTIONS)

override_dh_auto_install:
	scons install $(DEB_SCONS_OPTIONS)

override_dh_auto_clean:
	dh_auto_clean
	rm -rf .sconf_temp/ .sconsign.dblite config.log

=== debian/watch ===
# watch control file for uscan
version=3
http://www.v2v.cc/~j/ffmpeg2theora/download.html  .*/ffmpeg2theora-([\d\.]*)\.tar\.bz2
